#include <Keypad.h>

const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns
const int redPin = 10;
const int bluePin = 11;

//define the symbols on the buttons of the keypads
//from the custom_keypad file provided by the Arduino tools
char hexaKeys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};

int grid[] = {0,0,0,0,0,0,0,0,0};
bool isOsTurn = true;
bool squareWon = false;
bool circleWon = false;

//Also from the custom_keypad file provided by Arduino tools
byte rowPins[ROWS] = {9, 8, 7, 6}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {5, 4, 3, 2}; //connect to the column pinouts of the keypad

Keypad customKeypad = Keypad( makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS); 

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  pinMode(redPin, OUTPUT);
  pinMode(bluePin, OUTPUT);
}

void loop() {  
  if(squareWon)
  {
    digitalWrite(redPin, HIGH);
  } else if(circleWon) {
    digitalWrite(bluePin, HIGH);
  } else {
     makePlay();
     checkIfWinner();
  }
}

void printGrid(){
  for(int i=0;i<9;i++) {
      Serial.print(grid[i]);
      Serial.print(',');
  }
  Serial.println();
  isOsTurn = !isOsTurn;
}

void makePlay(){
    //get the value from the keypad and assign it to customKey
  char customKey = customKeypad.getKey();

  //Check the value of customKey and adjust the corresponding index in the array
  if(customKey == '1'){
    if(grid[0] == 0){
      if(isOsTurn) {
        grid[0] += 1;
      } else {
        grid[0] += 2;
      }
      printGrid();
    }
  } else if(customKey == '2'){
    if(grid[1] == 0){
      if(isOsTurn) {
        grid[1] += 1;
      } else {
        grid[1] += 2;
      }
      printGrid();
    }  
  } else if(customKey == '3'){
    if(grid[2] == 0){
      if(isOsTurn) {
        grid[2] += 1;
      } else {
        grid[2] += 2;
      }
      printGrid();
    }
  } else if(customKey == '4'){
    if(grid[3] == 0){
      if(isOsTurn) {
        grid[3] += 1;
      } else {
        grid[3] += 2;
      }
      printGrid();
    }
  } else if(customKey == '5'){
    if(grid[4] == 0){
      if(isOsTurn) {
        grid[4] += 1;
      } else {
        grid[4] += 2;
      }
      printGrid();
    }
  } else if(customKey == '6'){
    if(grid[5] == 0){
      if(isOsTurn) {
        grid[5] += 1;
      } else {
        grid[5] += 2;
      }
      printGrid();
    }
  } else if(customKey == '7'){
    if(grid[6] == 0){
      if(isOsTurn) {
        grid[6] += 1;
      } else {
        grid[6] += 2;
      }
      printGrid();
    }
  } else if(customKey == '8'){
    if(grid[7] == 0){
      if(isOsTurn) {
        grid[7] += 1;
      } else {
        grid[7] += 2;
      }
      printGrid();
    }
  } else if(customKey == '9'){
    if(grid[8] == 0){
      if(isOsTurn) {
        grid[8] += 1;
      } else {
        grid[8] += 2;
      }
      printGrid();
    }
  }
}

void checkIfWinner(){
  if((grid[0]==1 && grid[1]==1 && grid[2]==1) || 
     (grid[3]==1 && grid[4]==1 && grid[5]==1) || 
     (grid[6]==1 && grid[7]==1 && grid[8]==1) ||
     (grid[0]==1 && grid[3]==1 && grid[6]==1) ||
     (grid[1]==1 && grid[4]==1 && grid[7]==1) ||
     (grid[2]==1 && grid[5]==1 && grid[8]==1) ||
     (grid[0]==1 && grid[4]==1 && grid[8]==1) ||
     (grid[2]==1 && grid[4]==1 && grid[6]==1))
  {
    circleWon = true;
    Serial.print("Circle won");
  } else if((grid[0]==2 && grid[1]==2 && grid[2]==2) || 
     (grid[3]==2 && grid[4]==2 && grid[5]==2) || 
     (grid[6]==2 && grid[7]==2 && grid[8]==2) ||
     (grid[0]==2 && grid[3]==2 && grid[6]==2) ||
     (grid[1]==2 && grid[4]==2 && grid[7]==2) ||
     (grid[2]==2 && grid[5]==2 && grid[8]==2) ||
     (grid[0]==2 && grid[4]==2 && grid[8]==2) ||
     (grid[2]==2 && grid[4]==2 && grid[6]==2))
  {
    squareWon = true;
    Serial.print("Square won");
  }
}
